Index: TsDuration.cpp
===================================================================
--- TsDuration.cpp	(revision 27986)
+++ TsDuration.cpp	(working copy)
@@ -80,7 +80,6 @@
   {
     m_bSearchStart=true;
     m_bSearchEnd=false;
-    m_bSearchMax=false;
     m_startPcr.Reset();
     m_maxPcr.Reset();
     m_reader->SetFilePointer(0,FILE_BEGIN);
@@ -155,33 +154,6 @@
       LogDebug("Recovered wrong start PCR, seek to 'begin' on reused file ! ( Retried %d times )",4-Loop) ;
   }

-  //When the last pcr < first pcr then a pcr roll over occured
-  //find where in the file this rollover happened
-  //and fill maxPcr
-  if (m_endPcr.PcrReferenceBase < m_startPcr.PcrReferenceBase)
-  {
-    //PCR rollover
-    m_bSearchMax=true;
-    m_bSearchEnd=false;
-    __int64 offset=sizeof(buffer);
-    while (!m_maxPcr.IsValid)
-    {
-      DWORD dwBytesRead;
-      m_reader->SetFilePointer(-offset,FILE_END);
-      if (!SUCCEEDED(m_reader->Read(buffer,sizeof(buffer),&dwBytesRead)))
-      {
-        break;
-      }
-      if (dwBytesRead==0)
-      {
-        break;
-      }
-      Reset() ; // Reset internal "PacketSync" buffer
-      OnRawData(buffer,dwBytesRead);
-      offset+=sizeof(buffer);
-    }
-  }
-
   //park filepointer at end of file
   m_reader->SetFilePointer(-1,FILE_END);
   m_reader->Read(buffer,1,&dwBytesRead);
@@ -211,13 +183,6 @@
     {
       m_endPcr=field.Pcr;
     }
-    if (m_bSearchMax && m_pid==header.Pid)
-    {
-      if (field.Pcr.ToClock() >  m_startPcr.ToClock())
-      {
-        m_maxPcr=field.Pcr;
-      }
-    }
   }
 }

@@ -227,9 +192,12 @@
 // of the file (or timeshifting files)
 CRefTime CTsDuration::Duration()
 {
-  if (m_maxPcr.IsValid)
+  if (m_endPcr.PcrReferenceBase < m_startPcr.PcrReferenceBase)
   {
-    double duration= m_endPcr.ToClock() + (m_maxPcr.ToClock()- m_startPcr.ToClock());
+    CPcr pcr2;
+    pcr2.PcrReferenceBase = 0x1ffffffffULL;
+    pcr2.PcrReferenceExtension = 0x1ffULL;
+    double duration= m_endPcr.ToClock() + (pcr2.ToClock()- m_startPcr.ToClock());
     CPcr pcr;
     pcr.FromClock(duration);
     //LogDebug("Duration:%f %s", duration, pcr.ToString());
@@ -254,9 +222,12 @@
 // wrapped and reused.
 CRefTime CTsDuration::TotalDuration()
 {
-  if (m_maxPcr.IsValid)
+  if (m_endPcr.PcrReferenceBase < m_startPcr.PcrReferenceBase)
   {
-    double duration= m_endPcr.ToClock() + (m_maxPcr.ToClock()- m_firstStartPcr.ToClock());
+    CPcr pcr2;
+    pcr2.PcrReferenceBase = 0x1ffffffffULL;
+    pcr2.PcrReferenceExtension = 0x1ffULL;
+    double duration= m_endPcr.ToClock() + (pcr2.ToClock()- m_firstStartPcr.ToClock());
     CPcr pcr;
     pcr.FromClock(duration);
     //LogDebug("Duration:%f %s", duration, pcr.ToString());
